From: "'Kasturi Shekar' via isar-users" <isar-users@googlegroups.com>
To: isar-users@googlegroups.com
Cc: Kasturi Shekar <kasturi.shekar@siemens.com>
Subject: [PATCH] isar-installer: show progress bar during bmaptool copy process
Date: Tue, 18 Mar 2025 10:50:12 +0530 [thread overview]
Message-ID: <20250318052012.4701-1-kasturi.shekar@siemens.com> (raw)
In-Reply-To: <KLEL2lkm9BY>
- Added support for a progress gauge using a named pipe to capture and display
percentage progress when using `bmaptool`.
- The progress bar is displayed only when the `bmaptool` version is 3.8 or above,
as versions prior to 3.8 has some issues with `--psplash-pipe` flag.
- For `bmaptool` versions below 3.8, the image copy process continues without a
progress bar to maintain compatibility.
- The gauge uses `dialog --gauge` to dynamically update the progress based on
output from the `bmaptool` process.
Signed-off-by: Kasturi Shekar <kasturi.shekar@siemens.com>
---
.../files/usr/bin/deploy-image-wic.sh | 38 ++++++++++++++++++-
1 file changed, 37 insertions(+), 1 deletion(-)
diff --git a/meta-isar/recipes-installer/deploy-image/files/usr/bin/deploy-image-wic.sh b/meta-isar/recipes-installer/deploy-image/files/usr/bin/deploy-image-wic.sh
index 7f552eee..66c35506 100755
--- a/meta-isar/recipes-installer/deploy-image/files/usr/bin/deploy-image-wic.sh
+++ b/meta-isar/recipes-installer/deploy-image/files/usr/bin/deploy-image-wic.sh
@@ -149,7 +149,43 @@ if ! $installer_unattended; then
clear
fi
-if ! bmaptool copy ${bmap_options} "$installer_image_uri" "${installer_target_dev}"; then
+# Function to compare version numbers
+version_ge() {
+ if [ "$(printf '%s\n' "$1"X "$2" | sort -V | head -n 1)" != "$1"X ]; then
+ return 0
+ else
+ return 1
+ fi
+}
+
+# Get bmap-tools version
+bmap_version=$(bmaptool --version | awk '{ print $NF }')
+
+if version_ge "$bmap_version" "3.8"; then
+ # Create a named pipe for progress communication
+ progress_pipe="/tmp/progress"
+ if ! mkfifo "$progress_pipe"; then
+ echo "Error: Failed to create named pipe $progress_pipe"
+ exit 1
+ fi
+
+ # Add psplash pipe to bmap_options
+ bmap_options="$bmap_options --psplash-pipe=$progress_pipe"
+ quiet_flag="-q"
+
+ # Initialize the dialog gauge and update it dynamically
+ (
+ while true; do
+ if read -r line < "$progress_pipe"; then
+ percentage=$(echo "$line" | awk '{ print $2 }')
+ echo "$percentage"
+ fi
+ done
+ ) | dialog --gauge "Flashing image, please wait..." 10 70 0 &
+
+fi
+
+if ! bmaptool ${quiet_flag} copy ${bmap_options} "$installer_image_uri" "${installer_target_dev}"; then
exit 1
fi
--
2.39.5
--
You received this message because you are subscribed to the Google Groups "isar-users" group.
To unsubscribe from this group and stop receiving emails from it, send an email to isar-users+unsubscribe@googlegroups.com.
To view this discussion visit https://groups.google.com/d/msgid/isar-users/20250318052012.4701-1-kasturi.shekar%40siemens.com.
next prev parent reply other threads:[~2025-03-18 5:20 UTC|newest]
Thread overview: 12+ messages / expand[flat|nested] mbox.gz Atom feed top
[not found] <KLEL2lkm9BY>
2025-03-14 6:28 ` 'Kasturi Shekar' via isar-users
2025-03-17 5:49 ` 'Kasturi Shekar' via isar-users
2025-03-17 12:22 ` 'Quirin Gylstorff' via isar-users
2025-03-18 5:20 ` 'Kasturi Shekar' via isar-users [this message]
2025-03-18 6:05 ` 'Jan Kiszka' via isar-users
2025-03-19 9:42 ` [PATCH v5] " 'Kasturi Shekar' via isar-users
2025-03-27 10:32 ` Uladzimir Bely
2025-03-06 10:28 [PATCH] " 'Kasturi Shekar' via isar-users
2025-03-07 10:41 ` 'Jan Kiszka' via isar-users
2025-03-10 5:25 ` 'Shekar, Kasturi' via isar-users
2025-03-10 5:40 ` 'Shekar, Kasturi' via isar-users
2025-03-10 6:29 ` 'Jan Kiszka' via isar-users
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20250318052012.4701-1-kasturi.shekar@siemens.com \
--to=isar-users@googlegroups.com \
--cc=kasturi.shekar@siemens.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox